include ht48e30.inc

guardtime equ	3
clockrate equ 4000000         ;define clock rate here
guardconst	equ	(1+(guardtime*clockrate)/(4000*256*8))



vars	.section 'data'
delay1	db ?
delay2	db ?

		EXTERN 	trw_sendpacket:near,trw_getpacket:near,trw_setrx:near,trw_setch:near,trw_init:near,trw_address:near
		EXTERN	messge:byte


reset	.section at 0 'CODE'
		ORG 0
		jmp start

		ORG 0Ch
start:  clr	PC			;
		clr PB 
        set PAC					; PA0-7 = inputs
        mov a,0F0h				; PB0-3 = outputs, PB4-7 = inputs
		mov PBC,a
	    clr PCC					; PC0-7 = outputs
		set PGC					; PG0 = input

		call TXdelay			; Must wait at poweron before
		call trw_init			; init module (returns A=0)
		mov a,0					; select master
		call trw_address		; Set master address (to answer back)

main:	call trw_setrx			; Enable rx
mw4msg:	call trw_getpacket		; Get msg
		snz ACC.0				; A!=0, only bit0 checked (trw_getpacket returns 00 or FF)
		jmp mw4msg				; no, loop
		set PC.2
		call TXdelay 			; give the master some time to enable Rx (Rabbit CAN-045 waits 3ms after Tx)
		; insert real processing here, remove prior call when not needed
		mov a,041h				; yes, prepare ACK
		mov messge,a
		mov a,043h
		mov messge[1],a
		mov a,04Bh
		mov messge[2],a
		clr messge[3]
		call trw_sendpacket		; and answer back
		call TXdelay 			; must wait >3ms so Tx goes out
		clr PC.2
		jmp main


TXdelay:
		clr delay1
		mov a,guardconst
		mov delay2,a
l1:		jmp l1a
l1a:	jmp l1b
l1b:	nop
		sdz delay1
		jmp l1
		sdz delay2
		jmp l1
		ret

		.end
